#include "utils.h"
#include "sort.h"

bool ascending(int a, int b) {
    return a > b;
}

bool descending(int a, int b) {
    return a < b;
}

bool ascending_and_even(int a, int b) {
    return (ascending(a, b) && (a % 2 == 0));
}

bool ascending_and_odd(int a, int b) {
    return (ascending(a, b) && (a % 2 != 0));
}

static bool sort_first(int* array, unsigned length, criteria_cb criteria) {
    bool rt = false;
    for (unsigned i = 0; i < length-1; i++) {
        if (criteria(array[i], array[i+1])) {
            swap_int(&array[i], &array[i+1]);
            if (!rt) { rt = true; };
        }
    }
    return rt;
}

/* this function is awaited in the array.c file */
void sort_bubble_array(int* array, unsigned length, criteria_cb criteria) {
    bool rt;
    do {
        rt = sort_first(array, length, criteria);
   } while (rt);
}
